using Microsoft.ApplicationBlocks.Data;
using System;
using System.Collections;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Windows.Forms;

namespace Arbonne.Components.Win.Calendar
{
	/// <summary>
	/// Summary description for UserControl1.
	/// </summary>
	public class arbCalendar : System.Windows.Forms.UserControl
	{
		private Syncfusion.Windows.Forms.Tools.MonthCalendarAdv monthCalendarAdv1;
		private ArrayList calendarEvents = new ArrayList();
	
		private System.ComponentModel.Container components = null;

		public arbCalendar()
		{
			InitializeComponent();
			calendarEvents = new ArrayList();
			GetCalendar("Server=gmills;Database=CallCenter_Dev;uid=user;password=password");
		}

		
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if( components != null )
					components.Dispose();
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code

		private void InitializeComponent()
		{
			this.monthCalendarAdv1 = new Syncfusion.Windows.Forms.Tools.MonthCalendarAdv();
			((System.ComponentModel.ISupportInitialize)(this.monthCalendarAdv1)).BeginInit();
			this.SuspendLayout();
			// 
			// monthCalendarAdv1
			// 
			this.monthCalendarAdv1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.monthCalendarAdv1.Culture = new System.Globalization.CultureInfo("");
			this.monthCalendarAdv1.DaysFont = new System.Drawing.Font("Verdana", 8F);
			this.monthCalendarAdv1.DaysHeaderInterior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Vertical, System.Drawing.Color.PeachPuff, System.Drawing.Color.AntiqueWhite);
			this.monthCalendarAdv1.Location = new System.Drawing.Point(8, 0);
			this.monthCalendarAdv1.Name = "monthCalendarAdv1";
			this.monthCalendarAdv1.Size = new System.Drawing.Size(528, 581); 

			// 
			this.Name = "arbCalendar";
			((System.ComponentModel.ISupportInitialize)(this.monthCalendarAdv1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion


		public void LoadCalendar(string DBConnectionString)
		{
			GetCalendar(DBConnectionString);
		}

		private void GetCalendar(string DBConnectionString)
		{ 
			SqlDataReader drGetCalendar;
			DateTime strDate;
			string strTitle;
			string strDesc;

			drGetCalendar = SqlHelper.ExecuteReader(DBConnectionString, "CalendarGet");
			while (drGetCalendar.Read())
			{
				strDate = Convert.ToDateTime(drGetCalendar["Date"]);
				strTitle = drGetCalendar["Title"].ToString();
				strDesc =  drGetCalendar["Description"].ToString();
				this.calendarEvents.Add(new EventInfo(strDate, strTitle, strDesc));
				this.monthCalendarAdv1.RefreshCalendar(true);
			
			}
		}

		public void monthCalendarAdv1_DateCellQueryInfo(object sender, Syncfusion.Windows.Forms.Tools.DateCellQueryInfoEventArgs e)
		{
			
			foreach (EventInfo info in this.calendarEvents)
			{
				if (e.DateValue.Equals(info.Date.Date))
				{
					e.Style.Text = e.Style.Text + System.Environment.NewLine + info.Title ;
				}
			}
		}

		private void arbCalendar_Load(object sender, System.EventArgs e)
		{
		
		}

		private class EventInfo
		{
			private DateTime date;			
			private string title;
			private string desc;

			public EventInfo(DateTime eventDate, string eventTitle, string eventDesc)
			{
				Date = eventDate;				
				Title = eventTitle;
				Desc = eventDesc;
			}
			public DateTime Date
			{
				get
				{
					return date;
				}
				set
				{
					date = value;
					
				}
			}
			public string Title
			{
				get 
				{
					return title;
				}
				set 
				{
					title = value;
				}
			}
			public string Desc
			{
				get 
				{
					return desc;
				}
				set 
				{
					desc = value;
				}
			}
		}

	}
}
